﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ticktacktoe
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Choose your side, HUMAN:");
            Console.WriteLine("x or o");
            Console.WriteLine("Any other symbol if you would like to see AI vs AI battle");
            char side = Convert.ToChar(Console.ReadLine().ToLower());

            AI ai = new AI();
            int gameCount = 1;

            IPlayer playerX;
            IPlayer playerO;

            switch (side)
            {
                case 'x':
                    playerX = new Human('x');
                    playerO = new Machine('o', ai);
                    break;
                case 'o':
                    playerX = new Machine('x', ai);
                    playerO = new Human('o');
                    break;
                default:
                    playerX = new Machine('x', ai);
                    playerO = new Machine('o', ai);

                    Console.WriteLine("Enter game count");
                    gameCount = Convert.ToInt32(Console.ReadLine());

                    if (gameCount <= 0)
                    {
                        gameCount = 1;
                    }

                    break;
            }

            Game game = new Game();

            for (int i = 0; i < gameCount; i++)
            {
                Console.WriteLine();
                Console.WriteLine("New game #{0}", (i + 1));
                game.Start();
                //game.PrintField();
                while (true)
                {
                    if (game.IsDraw())
                    {
                        playerX.Draw();
                        playerO.Draw();
                        break;
                    }

                    playerX.MakeStep(game);
                    game.PrintField();
                    Console.WriteLine("\n\n");

                    if (game.IsWin(playerX.GetSide()))
                    {
                        playerX.Win();
                        playerO.Lose();
                        break;
                    }

                    if (game.IsDraw())
                    {
                        playerX.Draw();
                        playerO.Draw();
                        break;
                    }

                    playerO.MakeStep(game);
                    //game.PrintField();

                    if (game.IsWin(playerO.GetSide()))
                    {
                        playerO.Win();
                        playerX.Lose();
                        break;
                    }
                }
                game.PrintField();
            }
            ai.Save();
            Console.ReadKey();

        }
    }
}
